// Astrological Calculation Program
// Copyright 2000 by Brendan K Callahan, KB3EES
// This program may be freely distributed so long as it is not modified in
// any way, and the source code (AstroCal.cpp) and readme.txt is included.
// If you have code additions you would like to make, please mail them to
// pgh_artcars@hotmail.com

// When sending code additions, please document them *fully*--I am not the
// world's greatest programmer, and I need to be able to undestand what you
// are trying to do.  Not to mention this is the first program I have written
// in over 8 years--I'm a little rusty, ya know?

#include <iostream.h>
#include <dos.h>

//functions used

// function used to get a "valid" input for degrees (!< 0)
int correct_degree_entry();

// function used to get a "valid" input for minutes and seconds (!< 0 && !>=60)
int correct_minute_or_second_entry();

// function used to get a "valid" input for decimal degrees (!< 0)
float correct_input();

main()
{

int indegrees, inminutes, inseconds, desire, x;
float outdegrees, outminutes, outseconds, input, output;

cout<<"Welcome to AstroCal v.90b, a very basic calculator for astrology, or anything\n"
	 <<"else when conversion is desired from DMS to decimal, or vice versa.\nCopyright 2000 "
	 <<"Brendan K Callahan KB3EES. AstroCal is freeware: use and enjoy!\n"
	 <<"Send comments, bug reports or suggestions to pgh_artcars@hotmail.com";

do
	{
	// Find out what they want to do!
	cout<<"\n\nPlease enter 1 for DMS->Dec, or a 2 for Dec->DMS, anything else terminates:";
	cin>>desire;

	// Conversion of DMS (Degrees, minutes, seconds) to Decimal equivalent.
	if (desire == 1 )
		{
			// Ask for degree portion of DMS
			cout<<"\nDegrees:";
			cin>>indegrees;
			// Make sure it is non-negative.
			if (indegrees < 0 )indegrees=correct_degree_entry();

			// Ask for minute portion of DMS
			cout<<"Minutes:";
			cin>>inminutes;
			// Make sure it is 0 or greater, and less than 60
			// (There are 60 minutes to 1 degree)
			if (inminutes < 0 )inminutes=correct_minute_or_second_entry();
			if (inminutes >= 60 )inminutes=correct_minute_or_second_entry();

			// Ask for second portion of DMS
			cout<<"Seconds:";
			cin>>inseconds;
			// Make sure it is 0 or greater, and less than 60
			// (There are 60 seconds to 1 minute)
			if (inseconds < 0 )inseconds=correct_minute_or_second_entry();
			if (inseconds >= 60 )inseconds=correct_minute_or_second_entry();

			// compute decimal equiv. of DSM
			output= inseconds/60.0;
			output= (output + inminutes)/60.0;
			output= output + indegrees;
			// Display the answer
			cout<<"\n"<<indegrees<<"d "<<inminutes<<"m "<<inseconds<<"s = ";
			cout<<output<<" degrees.";

		};

	// Conversion of decimal equiv. to DMS
	if (desire == 2)
		{
		 // Ask for the decimal equiv.
		 cout<<"\nPlease enter the degrees as decimal:";
		 cin>>input;

		 // Make sure it is greater than zero
		 if (input < 0)input=correct_input();

		 // calculate degree portion of DMS
		 output=input;
		 x=input;
		 input=input - x;
		 outdegrees=x;

		 // calculate minute portion of DMS
		 input=input * 60.0;
		 x=input;
		 input=input - x;
		 outminutes=x;

		 // calculate second portion of DMS
		 input=input * 60.0;
		 x=input;
		 outseconds=x;

		 // Display the answer
		 cout<<"\n"<<output<<" degrees = "<<outdegrees<<"d "<<outminutes;
		 cout<<"m "<<outseconds<<"s.\n";
		}
	}
	// repeat until something other than a 1 or 2 is entered
	while (desire == 1 || desire == 2);
	// This is what is known as "making it 'user-friendly'"
	cout<<"Good bye!";
	// Don't want the mesage to dissappear too quickly!
	delay(1200);

return(0);
}




//functions:

int correct_degree_entry()
	{
	int indegrees;
	cout<<"\nYour entry must be greater than or equal to zero.";
	cout<<"\nPlease re-enter:";
	cin>>indegrees;
	// loop until they get it right (How to keep an idiot busy???)
	// this is recursive--it will call itself as many times as necessary
	if (indegrees < 0)indegrees=correct_degree_entry();
	return (indegrees);
	}


int correct_minute_or_second_entry()
	{
	int minutes_or_seconds;
	cout<<"\nYour entry must be greater than or equal to zero, and less than 60. ";
	cout<<"\nPlease re-enter:";
	cin>>minutes_or_seconds;
	// loop until they get it right (How to keep an idiot busy???)
	// this is recursive--it will call itself as many times as necessary
	if (minutes_or_seconds < 0)minutes_or_seconds=correct_minute_or_second_entry();
	if (minutes_or_seconds >= 60)minutes_or_seconds=correct_minute_or_second_entry();
	return (minutes_or_seconds);
	}


float correct_input()
	{
	float input;
	cout<<"\nYour entry must be greater than or equal to zero, and less than 30. ";
	cout<<"\nPlease re-enter:";
	cin>>input;
	// loop until they get it right (How to keep an idiot busy???)
	// this is recursive--it will call itself as many times as necessary
	if (input < 0)input=correct_input();
	return (input);
	}













